/*
 * Binaire.h
 *
 *  Created on: 27 mars 2015
 *      Author: michel
 */

#ifndef BINAIRE_H_
#define BINAIRE_H_

#include "Expression.h"

namespace modele {
//class Expression;

class Binaire : public Expression {
private:
  char op; // opérateur +,-,*,/
  Expression *gauche; // sous-exp de gauche
  Expression *droite; // sous-exp de droite

public:
  Binaire(char o, Expression *g, Expression *d) : op(o), gauche(g), droite(d) {
  }
  /** recopie (clone)
   * @return l'expression copiée
   */
  Expression *clone(){
    Expression *g=this->gauche->clone();
    Expression *d=this->droite->clone();
    return new Binaire(op,g,d);
  }

  /** Calcule la valeur d'une expression binaire infix dont l'opérateur est parmi : -, +, *, /
   * @return la valeur après exécution de l'op.
   */
  Valeur * calculer();

  std::string toString();

  void majRefRelatives(Reference *r);

  /** Destructeur d'une binaire : commence par détruire les deux sous-objets gauche et droit.
 */
  ~Binaire();
};

} /* namespace modele */

#endif /* BINAIRE_H_ */
