/*
 * Cellule.h
 *
 *  Created on: 26 mars 2015
 *      Author: michel
 */

#ifndef CELLULE_H_
#define CELLULE_H_

//#include "Reference.h"
#include "Expression.h"
#include <string>


namespace modele {
class Reference;
class Expression;
class Valeur;
/** une Cellule ne peut exister en dehors de sa feuille : lors de sa construction, elle est automatiquement insérée
 * dans la map de sa feuille.
 */
class Cellule {

private:
  Reference* ref;  // référence de la cellule
  std::string * saisie; // chaîne de saisie de l'utilisateur
  Expression* exp; //new ValVide(); // racine de l'expression :elle peut évoluer donc ptr
  //Valeur valeur; //=new ValVide(); // valeur courante
  //std::set<Cellule> dependDe; //=new HashSet<Cellule>(); // ensemble des cellules dont
  // dépend cette Cellule
  //private Set<ChangeListener> ecoutants=new HashSet<ChangeListener>();
  // ensemble des Cellules dépendantes
  bool calculEnCours; //=false;// marque de parcours pour fermeture
  // transitive

public:
  /** Constructeur par défaut */
  Cellule();

  /** Constructeur créant une Cellule vide ayant une valeur vide;
   *@param r la réf de la cellule
   */
  Cellule(Reference * r);


  /** Constructeur créant une Cellule. Il faut la reference et la saisie.
   *@param r la réf de la cellule
   *@param s la chaîne saisie
   *@param e l'expression arborescente
   */
  Cellule(Reference * r, std::string * s, Expression * e);

  /** retourne le calcul de l'expression stockée dans la cellule
   * @return la valeur
   */
  Valeur * calculer();
  /** Copie l'expression située dans cette cellule. L'arbre complet est cloné.
   * @return une nouvelle expression copie
   */
  Expression * copierExpression(){
    return exp->clone();
  }
  /** Destructeur de cellule détruisant la référence, la saisie et l'expression
   *
   */
  ~Cellule();

  Expression* getExpression() const {
    return exp;
  }

  void setExpression(Expression* exp) {
    this->exp = exp;
  }


};

} /* namespace modele */

#endif /* CELLULE_H_ */
