/*
 * Fonction.h
 *
 *  Created on: 8 avr. 2015
 *      Author: michel
 */

#ifndef FONCTION_H_
#define FONCTION_H_

#include <list>
#include "Expression.h"

namespace modele {

class Fonction: public Expression {
protected:

  /** Liste des paramètres de la fonction
    */
   std::list<Argument *> listeParam;


public:
   /** constructeur de Fonction par défaut. La liste des paramètres est initialisée à vide.
    *
    */
   Fonction(): listeParam(){}

   /** constructeur de Fonction initialisant la liste des arguments
    * @param larg liste des arguments
    */
  Fonction(std::list<Argument *> larg) : listeParam(larg){}


  /** Méthode virtuelle pure calculant la valeur de l'expression (arbre)
   * @return la valeur qui est un new objet et devra donc être delete.
   */
  virtual modele::Valeur * calculer()=0;  // virtuelle pure(=0), le retour doit être par réf (ou ptr) car on ne peut ret une classe abstraite
  /** Transmet la mise à jour de la référence dans chaque référence relative
   * @param r la nouvelle référence qui est celle de la cellule dans laquelle on colle
   */
  void majRefRelatives(Reference *r){
    for (Argument *e: listeParam){
      e->majRefRelatives(r);
    }
  }

  ~Fonction() {}
};

} /* namespace modele */

#endif /* FONCTION_H_ */
