/*
 * RefRelative.h
 *
 *  Created on: 2 avr. 2015
 *      Author: michel
 */

#ifndef REFRELATIVE_H_
#define REFRELATIVE_H_

#include "Expression.h"
#include "Feuille.h"
#include "Cellule.h"
#include "ValVide.h"
#include "Ref.h"

namespace modele {

class RefRelative: public Ref {
private:
  Reference *pref;
  int deplLigne;
  int deplCol;
public:
  RefRelative(Reference * pr, int dl, int dc) :
      pref(pr), deplLigne(dl), deplCol(dc) {
    // TODO Auto-generated constructor stub

  }

  Valeur * calculer() {
    Feuille *f = pref->getFeuille();  // feuille courante
    Reference *r = new Reference(pref->getLigne() + deplLigne,
        pref->getColonne() + deplCol, f); // réf absolue
    Cellule * c = f->getCellule(*r);
    if (c == NULL)
      return new ValVide(); // valeur nulle
    else
      return c->calculer();
  }
  Reference toAbsolue() {
    int c = pref->getColonne() + deplCol;
    int l = pref->getLigne() + deplLigne;
    return Reference(l, c, pref->getFeuille());
  }
  std::string toString() {
    return toAbsolue().toString();
  }

  Expression *clone() {
    return new RefRelative(*this);
  }

  void majRefRelatives(Reference *r){
    pref=r;
  }
  ~RefRelative() {
    // TODO Auto-generated destructor stub
  }
};

} /* namespace modele */

#endif /* REFRELATIVE_H_ */
