/*
 * RefRelativeCol.h
 *
 *  Created on: 2 avr. 2015
 *      Author: michel
 */

#ifndef REFRELATIVECol_H_
#define REFRELATIVECol_H_

#include "Expression.h"
#include "Reference.h"
#include "Cellule.h"
#include "ValVide.h"
#include "Feuille.h"
#include "Ref.h"

namespace modele {

class RefRelativeCol: public Ref {
private:
  Reference *pref;
  int deplCol;
  int ligne;
public:
  RefRelativeCol(Reference * pr,int l,int dc):pref(pr),deplCol(dc),ligne(l) {
    // TODO Auto-generated constructor stub

  }

  Valeur * calculer() {
    Feuille *f=pref->getFeuille();  // feuille courante
    Reference *r=new Reference(ligne,pref->getColonne()+deplCol, f); // réf absolue
    Cellule * c = f->getCellule(*r);
    if (c == NULL)
      return new ValVide(); // valeur nulle
    else
      return c->calculer();
  }

  Reference toAbsolue(){
    int c=pref->getColonne()+deplCol;
    return Reference(ligne,c,pref->getFeuille());
  }
  std::string toString(){
    return toAbsolue().toString();
  }

  Expression *clone(){
    return new RefRelativeCol(*this);
  }
  void majRefRelatives(Reference *r){
    pref=r;
  }
  ~RefRelativeCol() {
    // TODO Auto-generated destructor stub
  }
};

} /* namespace modele */

#endif /* REFRELATIVECol_H_ */
