/*
 * RefRelativeLigne.h
 *
 *  Created on: 2 avr. 2015
 *      Author: michel
 */

#ifndef REFRELATIVELIGNE_H_
#define REFRELATIVELIGNE_H_

#include "Expression.h"
#include "Reference.h"
#include "Feuille.h"
#include "Cellule.h"
#include "ValVide.h"
#include "Ref.h"


namespace modele {

class RefRelativeLigne: public Ref {
private:
  Reference *pref;
  int deplLigne;
  int col;
public:
  RefRelativeLigne(Reference * pr,int dl,int c):pref(pr),deplLigne(dl),col(c) {
    // TODO Auto-generated constructor stub

  }

  Valeur * calculer() {
    Feuille *f=pref->getFeuille();  // feuille courante
    Reference *r=new Reference(pref->getLigne()+deplLigne, col, f); // réf absolue
    Cellule * c = f->getCellule(*r);
    if (c == NULL)
      return new ValVide(); // valeur nulle
    else
      return c->calculer();
  }

  Reference toAbsolue(){
    int l=pref->getLigne()+deplLigne;
    return Reference(l,col,pref->getFeuille());
  }
  std::string toString(){
    return toAbsolue().toString();
  }

  Expression *clone(){
    return new RefRelativeLigne(*this);
  }
  void majRefRelatives(Reference *r){
    pref=r;
  }
  ~RefRelativeLigne() {
    // TODO Auto-generated destructor stub
  }
};

} /* namespace modele */

#endif /* REFRELATIVELIGNE_H_ */
