/*
 * ValChaine.h
 *
 *  Created on: 25 mars 2015
 *      Author: michel
 */

#ifndef VALChaine_H_
#define VALChaine_H_

#include "Valeur.h"

namespace modele {

/** La classe ValChaine représente une Valeur de Chaine sous forme de chaîne
 * @author Michel Meynard
 * @version 1.0
 */
class ValChaine: public Valeur {
private:
  std::string valeur;  // attribut spécifique de ValChaine

public:
  ValChaine(const std::string msg):valeur(msg){}

  ValChaine(const char msg[]){valeur=std::string(msg);}

  //ValChaine(char const * msg){valeur=std::string(msg);}// fonctionne aussi bien que la précédente

  std::string toString(){return valeur;}

  Valeur * calculer(){return new ValChaine(valeur);}

  Expression *clone(){return new ValChaine(valeur);}

  ~ValChaine(){}

};

} /* namespace modele */

#endif /* VALChaine_H_ */
