/*
 * ValDouble.h
 *
 *  Created on: 25 mars 2015
 *      Author: michel
 */

#ifndef VALDouble_H_
#define VALDouble_H_

#include <string>
#include "Valeur.h"

namespace modele {

/** La classe ValDouble représente une Valeur double
 * @author Michel Meynard
 * @version 1.0
 */
class ValDouble: public Valeur {
private:
  double valeur;	// attribut spécifique de ValDouble

public:
  /** Constructeur créant une ValDouble
   * @param d le double
   */
  ValDouble(double d):valeur(d){}
  /** accesseur de la valeur double
   * @return la valeur double
   */
  double getDouble(){
    return valeur;
  }
  /** Fonction retournant une chaîne à 6 chiffres après le point décimal représentant le double
   * @return la chaîne
   */
  std::string toString(){return std::to_string(valeur);}

  Valeur * calculer(){return new ValDouble(valeur);}

  Expression *clone(){return new ValDouble(valeur);}

  ~ValDouble(){}

};

} /* namespace modele */

#endif /* VALDouble_H_ */
