/*
 * ValErreur.h
 *
 *  Created on: 25 mars 2015
 *      Author: michel
 */

#ifndef VALERREUR_H_
#define VALERREUR_H_

#include "Valeur.h"

namespace modele {

/** La classe ValErreur représente une Valeur d'Erreur sous forme de chaîne
 * @author Michel Meynard
 * @version 1.0
 */
class ValErreur: public Valeur {
private:
  std::string valeur;  // attribut spécifique de ValErreur

public:
  ValErreur(std::string msg):valeur(msg){}

  ValErreur(char const * msg){valeur=std::string(msg);}

  std::string toString(){return valeur;}

  Valeur * calculer(){return new ValErreur(valeur);}

  Expression *clone(){return new ValErreur(valeur);}

  ~ValErreur(){};

};

} /* namespace modele */

#endif /* VALERREUR_H_ */
