/*
 * Valeur.h
 *
 *  Created on: 25 mars 2015
 *      Author: michel
 */

#ifndef VALEUR_H_
#define VALEUR_H_

#include "Expression.h"

namespace modele {

/** La classe abstraite Valeur représente une valeur parmi : ValErreur, ValDouble, ValChaine, ValVide
 * @author Michel Meynard
 * @version 1.0
 */
class Valeur: public modele::Expression {
public:
  virtual std::string toString()=0;  // virtuelle pure(=0)

  virtual Valeur * calculer()=0; // ne peut retourner this car la valeur calculée est ensuite deletee par l'expression parent

  virtual ~Valeur(){}
  // Une classe abstaite doit avoir un destructeur virtuel : lors du delete de l'objet d'une sous-classe A* a=new B()
  // c'est le destructeur de B qui sera appelé (et qui appellera celui de A);

};

} /* namespace modele */

#endif /* VALEUR_H_ */
